/* ParameterloseMethoden.java */

import java.io.*;
import java.lang.reflect.*;

class Person1
{
  public void gibName()
  {
    System.out.println("Mustermann");
  }
  public void gibVorname()
  {
    System.out.println("Erika");
  }
}

public class ParameterloseMethoden
{
  public static void main(String[] args)
  {
    String buf = "";
    BufferedReader in = new BufferedReader(
                        new InputStreamReader(
                        new DataInputStream(System.in)));
    while (true) {
    try {
        System.out.print("Klassenname oder ende eingeben: ");
        buf = in.readLine();
        if (buf.equals("ende")) {
          break;
        }
        Class c = Class.forName(buf);
        Object o = c.newInstance();
        Method[] methods = c.getMethods();
        for (int i=0; i < methods.length; i++)
        {
        	String name = methods[i].getName();
        	// Methodenname beginnt nicht mit gib?
        	if (!name.startsWith("gib")) continue;
        	// Methode parameterlos?
        	Class[] params = methods[i].getParameterTypes();
        	if (params.length > 0) continue;
        	// Methode static?
        	int modifiers = methods[i].getModifiers();
        	if (Modifier.isStatic(modifiers)) continue;
        	System.out.println("Aufgerufen wird die Methode " + name);
        	try {
        		methods[i].invoke(o, new Object[0]);
        	} catch (Exception e) {
        		System.out.println(e.toString());
        	}
        }
      } catch (IOException e) {
        System.out.println(e.toString());
      } catch (ClassNotFoundException e) {
        System.out.println("Klasse nicht gefunden");
      } catch (ClassCastException e) {
        System.out.println(e.toString());
      } catch (InstantiationException e) {
        System.out.println(e.toString());
      } catch (IllegalAccessException e) {
        System.out.println(e.toString());
      }
    }
  }
}