/* ParametrisierteMethoden.java */

import java.io.*;
import java.lang.reflect.*;

class Person2
{
	int alter;
	
	public int setzeAlter(int alter)
	{
		this.alter = alter;
		return 12*alter;
	}
}

public class ParametrisierteMethoden
{
  public static void main(String[] args)
  {
  	try {
        Class c = Class.forName("Person2");
        Object o = c.newInstance();
        Class[] formparams = new Class[1];
		formparams[0] = Integer.TYPE;
        Method method = c.getMethod("setzeAlter", formparams);
		Object[] actargs = new Object[1];
		actargs[0] = new Integer(37);
		System.out.println("Aufgerufen wird setzeAlter(37) bei Person2");
		System.out.println("setzeAlter hat den Returntyp " + method.getReturnType());
        try {
        	Integer ret = (Integer)method.invoke(o, actargs);
        	System.out.println("Rckgabewert: " + ret.intValue());
       	} catch (Exception e) {
        	System.out.println(e.toString());
        }
     } catch (NoSuchMethodException e) {
        System.out.println(e.toString());
      } catch (ClassNotFoundException e) {
        System.out.println("Klasse nicht gefunden");
      } catch (ClassCastException e) {
        System.out.println(e.toString());
      } catch (InstantiationException e) {
        System.out.println(e.toString());
      } catch (IllegalAccessException e) {
        System.out.println(e.toString());
      }      
  }
}